/*
//  CWFoundation.h
//  Zangetsu
//
//  Created by Colin Wheeler on 12/16/10.
//  Copyright 2010. All rights reserved.
//
 
 Copyright (c) 2013, Colin Wheeler
 All rights reserved.
 
 Redistribution and use in source and binary forms, with or without
 modification, are permitted provided that the following conditions are met:
 
 - Redistributions of source code must retain the above copyright notice, this
 list of conditions and the following disclaimer.
 
 - Redistributions in binary form must reproduce the above copyright notice,
 this list of conditions and the following disclaimer in the documentation
 and/or other materials provided with the distribution.
 
 THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
 FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
 SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
 
#import <Foundation/Foundation.h>

/**
 Inspired by println in Go, Prints all the variables, space seperated,to NSLog()
 
 Creates a string by calling description on each variable and concatenating all
 those strings together separated by spaces and then logs that string to NSLog.
 
 @args all the variables you want printed to NSLog()
 */
void CWPrintLine(NSArray *args);

/**
 Inspired by println in Go, Prints all the variable, space separated, to printf
 
 Creates a string by calling description on each variable and concatenating all
 those strings together separated by spaces and then converts that to a const
 char c string and logs that through printf.
 
 @args all the variables you want printed to printf()
 */
void CWPrintfLine(NSArray *args);

/**
 Returns a unique NSString prepended by the passed in string
 
 @param preString the string to be prepended on the unique string
 @return NSString with a UUID String prepended with the prestring argument
 */
NSString *CWUUIDStringPrependedWithString(NSString *preString);
